try:
	import pylab as p
except ImportError:
	print "could not import pylab, matplotlib has not been installed, no plotting capabilities enabled"

from checkplotoptions import checkplotoptions
from plot_mesh import plot_mesh
from processmesh import processmesh
from processdata import processdata
from plot_unit import plot_unit
from applyoptions import applyoptions
from plot_overlay import plot_overlay

def plot_manager(md,options,subplotwidth,nlines,ncols,i):
	'''
	PLOT_MANAGER - distribute the plots called by plotmodel

		Usage:
			plot_manager(md,options,subplotwidth,i);

		See also: PLOTMODEL, PLOT_UNIT
	'''

	#parse options and get a structure of options
	options=checkplotoptions(md,options)

	#get data to be plotted
	data=options.getfieldvalue('data');

	#initialize plot handle variable
	handle=None

	# initialize subplot
	p.subplot(nlines,ncols,i,aspect='equal')

	##basemap plot
	#if options.exist('basemap'):
	#	plot_basemap(md,data,options,nlines,ncols,i)

	#overlay plot
	if options.exist('overlay'):
		handle=plot_overlay(md,data,options,nlines,ncols,i)
		options.addfielddefault('alpha',0.5)
		options.addfielddefault('xlim',[min(md.mesh.x),max(md.mesh.x)])
		options.addfielddefault('ylim',[min(md.mesh.y),max(md.mesh.y)])

	#figure out if this is a special plot
	if isinstance(data,(str,unicode)):

		# convert string to lower case for a case-insensitive comparison
		if data.lower()=='mesh': 
			plot_mesh(md,options,nlines,ncols,i)
			return
		elif data.lower()=='none':
			print 'no data provided to plot (TODO: write plot_none.py)'
			return
		else:
			print "WARNING: '%s' is not implemented or is not a valid string for option 'data'" % data

	#elif data in vars(md):
	#else:
		#print "'data' not a string, plotting model properties yet to be implemented..."

	#Gridded plot

	#Section plot

	#Profile plot

	#process data and model
	x,y,z,elements,is2d,isplanet=processmesh(md,data,options)
	data2,datatype=processdata(md,data,options)

	#standard plot
	#if not handle:
	#	p.subplot(nlines,ncols,i,aspect='equal')

	#plot unit
	plot_unit(x,y,z,elements,data2,is2d,isplanet,datatype,options)

	#apply all options
	applyoptions(md,data2,options)
	
	#ground overlay on kml plot_unit
